function demo_fish(rand_points_num)

load save_fish_def_3_1.mat
p1 = y1;
p2 = y2a;

y1 = floor(p1 * 200 + 200);

t = rand(1,1)*360/180*pi;
T  = [cos(t) -sin(t);
      sin(t) cos(t)];
y0 = T*(p1'-0.5) + 0.5;
scale = rand(1,1) + 0.5; 
y0 = floor(200*scale*y0'+800);


rd_points = rand(rand_points_num,2);
y2 = [p2; rd_points];
y2 = T*(y2'-0.5) + 0.5;
y2 = floor(y2'*200*scale + 400);

%%%%%%%%%%% Build the template %%%%%%%%%%
fid = fopen('point.txt', 'wt');
for n = 1 : size(y1,1)
   fprintf(fid, '%d %d\n', y1(n,1), y1(n,2));
end   
fclose(fid);

system('./mesh > my.txt');
system('python simp.py');
system('./point > p_seq.txt');

p_seq = load('p_seq.txt');
[feature1, md1] = scf(p_seq, []);

[ism, id] = ismember(p_seq, y1, 'rows');
y1_target = y2(id,:);
y0_reord = y0(id,:);
dx0 = [p_seq(:,1), p_seq(:,2), y0_reord(:,1)];
dy0 = [p_seq(:,1), p_seq(:,2), y0_reord(:,2)];
save dx0.txt dx0 -ascii
save dy0.txt dy0 -ascii

p_des = y2;
save p_des.txt p_des -ascii
[feature2, md2] = scf(y2, md1);

cc = ones(size(feature1,1), size(feature2,1)) * 1e10;
for n = 1 : 12
  for m = 1 : size(feature1, 1)
      h = feature1(m, :);
      h = reshape(h, 12, 5);
      hh = [h(2:12,:); h(1,:)];
      feature1(m,:) = reshape(hh, 1, 60);
   end
   cx = hist_cost_2(feature1, feature2);
   cc = min(cx, cc);
end

disp('scale 1');

[feature2, md2] = scf(y2, 0.5*md1);
for n = 1 : 12
  for m = 1 : size(feature1, 1)
      h = feature1(m, :);
      h = reshape(h, 12, 5);
      hh = [h(2:12,:); h(1,:)];
      feature1(m,:) = reshape(hh, 1, 60);
   end
   cx = hist_cost_2(feature1, feature2);
   cc = min(cx, cc);
end

disp('scale 2');

[feature2, md2] = scf(y2, 0.75*md1);
for n = 1 : 12
  for m = 1 : size(feature1, 1)
      h = feature1(m, :);
      h = reshape(h, 12, 5);
      hh = [h(2:12,:); h(1,:)];
      feature1(m,:) = reshape(hh, 1, 60);
   end 
   cx = hist_cost_2(feature1, feature2);
   cc = min(cx, cc);
end

disp('scale 3');

[feature2, md2] = scf(y2, 1.25*md1);
for n = 1 : 12
  for m = 1 : size(feature1, 1)
      h = feature1(m, :);
      h = reshape(h, 12, 5);
      hh = [h(2:12,:); h(1,:)];
      feature1(m,:) = reshape(hh, 1, 60);
   end 
   cx = hist_cost_2(feature1, feature2);
   cc = min(cx, cc);
end

disp('scale 4');

[feature2, md2] = scf(y2, 1.5*md1);
for n = 1 : 12
  for m = 1 : size(feature1, 1)
      h = feature1(m, :);
      h = reshape(h, 12, 5);
      hh = [h(2:12,:); h(1,:)];
      feature1(m,:) = reshape(hh, 1, 60);
   end
   cx = hist_cost_2(feature1, feature2);
   cc = min(cx, cc);
end

disp('scale 5');

[feature2, md2] = scf(y2, 1.75*md1);
for n = 1 : 12
  for m = 1 : size(feature1, 1)
      h = feature1(m, :);
      h = reshape(h, 12, 5);
      hh = [h(2:12,:); h(1,:)];
      feature1(m,:) = reshape(hh, 1, 60);
   end
   cx = hist_cost_2(feature1, feature2);
   cc = min(cx, cc);
end

disp('scale 6');

[feature2, md2] = scf(y2, 2*md1);
for n = 1 : 12
  for m = 1 : size(feature1, 1)
      h = feature1(m, :);
      h = reshape(h, 12, 5);
      hh = [h(2:12,:); h(1,:)];
      feature1(m,:) = reshape(hh, 1, 60);
   end
   cx = hist_cost_2(feature1, feature2);
   cc = min(cx, cc);
end

disp('scale 7');

save cost.txt cc -ascii

h1=800; w1=800;
h2=800; w2=800;

range = 1;
para = [size(p_seq,1), size(p_des,1), range, w1, h1, w2, h2];
save para.txt para -ascii
system('./cost < para.txt');
system('python lpx1.py | ./lpsol_stdin');

obj1 = load('obj.txt')
system('cp dxf.txt dxf1.txt');
system('cp dyf.txt dyf1.txt');

system('python lpx2.py | ./lpsol_stdin');
obj2 = load('obj.txt')
system('cp dxf.txt dxf2.txt');
system('cp dyf.txt dyf2.txt');

system('python lpx3.py | ./lpsol_stdin');
obj3 = load('obj.txt')
system('cp dxf.txt dxf3.txt');
system('cp dyf.txt dyf3.txt');

system('python lpx4.py | ./lpsol_stdin');
obj4 = load('obj.txt')
system('cp dxf.txt dxf4.txt');
system('cp dyf.txt dyf4.txt');

objs = [obj1 obj2 obj3 obj4];
[v, id] = min(objs);
cmd = sprintf('cp dxf%d.txt dxf.txt', id);
system(cmd);
cmd = sprintf('cp dyf%d.txt dyf.txt', id);
system(cmd);
showtrisc;
drawnow;
 
refine_fish(id);




