%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Linear Method for Scale and Rotation Invariant Matching
%    
%    Hao Jiang, Boston College, July 2009
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

fname1 = 'toy1.bmp';
im = imread(fname1);
im = im2double(im);
imc1 = im;
imwrite(im, 'tmp.pgm');
imshow(im);

[mask, xc, yc] = roipoly(im);
mask = im2double(mask);
save mask.mat mask
[image1, des1, loc] = sift('tmp.pgm');
z = [];
ff = [];
for n = 1 : size(loc,1)
    r = floor(loc(n,2));
    c = floor(loc(n,1));
    if r > 0 & c > 0 & mask(r, c) == 1 
        z = [z; floor(loc(n,1:2)), loc(n,3:4)];
        ff = [ff; des1(n,:)]; 
    end
end
hold on;

plot(z(:,1), z(:,2), '+');

fid = fopen('point.txt', 'wt');
for n = 1 : size(z,1)
   fprintf(fid, '%d %d\n', z(n,1), z(n,2));
end   
fclose(fid);

system('./mesh > my.txt');
system('python simp.py');
system('./point > p_seq.txt');

p_seq = load('p_seq.txt');
[ism, id] = ismember(p_seq, z(:,1:2), 'rows');
feature1 = ff(id,:);

%%%%%%%%%% Loop over all video frames %%%%%%

fname2 =  sprintf('toy3.bmp');

im = imread(fname2);
imc2 = im2double(im);
imwrite(im, 'tmp.pgm');
[image2, feature2, loc2] = sift('tmp.pgm');

q = floor(loc2(:,1:2));
p = unique(q,'rows');
[ism,id] = ismember(p, q, 'rows');
p_des = q(id,:);
save p_des.txt p_des -ascii
feature2 = feature2(id,:)';

dotprods = feature1 * feature2; 
cc = acos(dotprods)/pi*2;  
save cost.txt cc -ascii
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

q = floor(loc2(:,1:2));
p = unique(q,'rows');
[ism,id] = ismember(p, q, 'rows');
p_des = q(id,:);
save p_des.txt p_des -ascii

[h1,w1] = size(image1);
[h2,w2] = size(image2);

range = 1;
para = [size(p_seq,1), size(p_des,1), range, w1, h1, w2, h2];
save para.txt para -ascii
system('./cost < para.txt');
system('python lpx1.py | ./lpsol_stdin');

im1 = image1;
im2 = image2;
obj1 = load('obj.txt')
system('cp dxf.txt dxf1.txt');
system('cp dyf.txt dyf1.txt');

system('python lpx2.py | ./lpsol_stdin');  
obj2 = load('obj.txt')
system('cp dxf.txt dxf2.txt');
system('cp dyf.txt dyf2.txt');

system('python lpx3.py | ./lpsol_stdin');
obj3 = load('obj.txt')
system('cp dxf.txt dxf3.txt');
system('cp dyf.txt dyf3.txt');

system('python lpx4.py | ./lpsol_stdin');
obj4 = load('obj.txt')
system('cp dxf.txt dxf4.txt');
system('cp dyf.txt dyf4.txt');

objs = [obj1 obj2 obj3 obj4];
[v, id] = min(objs);
cmd = sprintf('cp dxf%d.txt dxf.txt', id);
system(cmd);
cmd = sprintf('cp dyf%d.txt dyf.txt', id);
system(cmd);
showtri;
drawnow;
refine(im1, im2, range, id);
showtri;

