function [image, descriptors, locs] = sift(imageFile)

image = imread(imageFile);
[rows, cols] = size(image); 

f = fopen('tmp.pgm', 'w');
if f == -1
    error('Could not create file tmp.pgm.');
end
fprintf(f, 'P5\n%d\n%d\n255\n', cols, rows);
fwrite(f, image', 'uint8');
fclose(f);

command = './sift -t 0 -e 0 tmp.pgm > tmp.key';
system(command);

system('cat tmp.key | wc -l > tmp.out');
num = load('tmp.out');

g = fopen('tmp.key', 'r');
if g == -1
    error('Could not open file tmp.key.');
end

locs = double(zeros(num, 4));
descriptors = double(zeros(num, 128));

for i = 1:num
    [vector, count] = fscanf(g, '%f %f %f %f', [1 4]); 
    if count ~= 4
        error('Invalid keypoint file format');
    end
    locs(i, :) = vector(1, :);
    
    [descrip, count] = fscanf(g, '%d', [1 128]);
    if (count ~= 128)
        error('Invalid keypoint file value.');
    end
    descrip = descrip / sqrt(sum(descrip.^2));
    descriptors(i, :) = descrip(1, :);
end
fclose(g);


